{-# LANGUAGE ConstraintKinds            #-}
{-# LANGUAGE DeriveGeneric              #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}

module Krobotkin.Monad where

import Krobotkin.Types

import Control.Monad.Reader
import Control.Monad.State

newtype BotMonad a = BotMonad
   (ReaderT AppEnv (StateT AppState IO) a)
   deriving
      ( Functor
      , Applicative
      , Monad
      , MonadReader AppEnv
      , MonadState AppState
      , MonadIO
      )

runBotMonad :: AppEnv -> AppState -> BotMonad a -> IO a
runBotMonad env appstate (BotMonad m) =
   evalStateT (runReaderT m env) appstate
