module Krobotkin.Options where

import Options.Applicative

data Flags = Flags
   { flagUsername :: String
   , flagServer   :: String
   , flagPassword :: String
   , flagMucs     :: [String]
   } deriving Show

options :: Parser Flags
options = Flags
   <$> strOption
       ( long "username"
      <> short 'u'
      <> metavar "USERNAME"
      <> help "xmpp username" )
   <*> strOption
       ( long "server"
      <> short 's'
      <> metavar "SERVER"
      <> help "xmpp server" )
   <*> strOption
       ( long "password"
      <> short 'p'
      <> metavar "PASSWORD"
      <> help "account password" )
   <*> multiString
       ( long "mucs"
      <> short 'm'
      <> metavar "MUC"
      <> help "muc to join" )

multiString :: Mod OptionFields [String] -> Parser [String]
multiString desc = concat <$> many single
   where
      single = option (str >>= return . words) desc

getOptions :: ParserInfo Flags
getOptions = info (options <**> helper)
    ( fullDesc
   <> header "krobotkin - an xmpp muc bot"
   <> progDesc "a friendly bot for your xmpp mucs :)" )
