module Krobotkin.Stanza where

import Krobotkin.Muc
import Krobotkin.Types

import Network.Xmpp
import Network.Xmpp.Internal

import Data.Char

import qualified Data.Text as T

packStanza :: Stanza -> PackedStanza
packStanza (MessageS m) = packMessage m
packStanza (PresenceS p) = packPresence p
packStanza _ = BotIgnore

packPresence :: Presence -> PackedStanza
packPresence p =
   case (presenceFrom p) of
      Just f -> BotPresence f (presenceType p) p
      _ -> BotIgnore

packMessage :: Message -> PackedStanza
packMessage m =
   let toUser = messageTo m
       fromUser = messageFrom m
   in case (messageType m) of
      GroupChat -> case getMucMessageBody m of
         Nothing -> BotIgnore
         Just b -> case (toUser,fromUser) of
            (Just t, Just f) -> BotMessage t f (map toUpper (T.unpack b)) m
            _ -> BotIgnore
      _ -> BotIgnore

