{-# LANGUAGE OverloadedStrings          #-}

module Main where

import Krobotkin.Handlers
import Krobotkin.Monad
import Krobotkin.Muc
import Krobotkin.Options
import Krobotkin.Setup
import Krobotkin.Stanza
import Krobotkin.Types

import Control.Monad
import Control.Monad.Reader

import Network.Xmpp
import Options.Applicative

main :: IO ()
main = do
   opts <- execParser getOptions
   env <- createEnv opts
   state <- createState
   runBotMonad env state $ do
      mucs <- asks envMucInfo
      mapM_ joinMuc mucs
      mapM_ (sendMucMessage "greetings, comrades!") $ map mucJid mucs
      sess <- asks envXmppSess
      forever $ do
        (st,_) <- liftIO $ getStanza sess
        dispatchStanza $ packStanza st
